//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "QSpgpPass.h"
#include "fileman.h"
#include "pgp.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPassphrase *Passphrase=NULL;
//---------------------------------------------------------------------------
__fastcall TPassphrase::TPassphrase(TComponent* Owner)
  : TDataModule(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::PassphraseCreate(TObject *Sender)
{
   phrases = new TStringList();
   Timer->Enabled = false;
   sessionKey = NULL;
   seconds = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::PassphraseDestroy(TObject *Sender)
{
   Clear(); if (phrases) delete phrases;
   phrases = NULL;
}
//---------------------------------------------------------------------------
char*__fastcall TPassphrase::GetSessionKey()
{
   if (!sessionKey) sessionKey = (char*)ActMainForm->Perform(WM_GETSESSIONKEY,0,0);
   return sessionKey;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::TimerTimer(TObject *Sender)
{
   seconds--; if (seconds<=0) Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Clear()
{
   Timer->Enabled = false; seconds = 0;
   if (phrases) while (phrases->Count)
   {
      delete phrases->Objects[0];
      phrases->Delete(0);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Add(AnsiString idtext8, AnsiString phrase)
{
   Timer->Enabled = false;
   seconds = KEEPPASSWORDMIN*60;
   if (seconds<1) return;

   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   Delete(idtext8);

   TDataBuf *phrasebuf = new TDataBuf(phrase.c_str(),phrase.Length());
   phrasebuf->sensitive = true;
   phrasebuf->Encrypt(GetSessionKey());
   phrases->AddObject(idtext8,phrasebuf);
   Timer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Delete(AnsiString idtext8)
{
   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   int idx; if ((idx=phrases->IndexOf(idtext8))>=0)
   {
      delete phrases->Objects[idx];
      phrases->Delete(idx);
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPassphrase::Get(AnsiString idtext8)
{
   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);

   AnsiString phrase;
   int idx; if ((idx=phrases->IndexOf(idtext8))>=0)
   {
      TDataBuf *phrasebuf = (TDataBuf*)phrases->Objects[idx];
      phrasebuf->Decrypt(GetSessionKey());
      phrase = phrasebuf->str();
   }
   return phrase;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPassphrase::Get(TStrings *idtext8s, AnsiString &idtext8)
{
   AnsiString phrase;
   for (int i=0; i<idtext8s->Count; i++)
   {
      idtext8 = idtext8s->Strings[i];
      if ((phrase=Get(idtext8))!="")
         break;
   }
   return phrase;
}
//---------------------------------------------------------------------------
